#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

//needed for parallel port interfacing
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>

//needed for xosd; not sure how to make this work
//#include <xosd.h>
//#include "/usr/local/include/xosd.h"


int dev_port_fd = -1;
GtkWidget *window3;
GtkWidget *window4;
GtkWidget *window5;
GtkWidget *window8;
GtkWidget *window7;
GtkWidget *window9;

static void destroy( GtkWidget *widget,
                     gpointer   data )
{
    gtk_main_quit ();
}

void open_io()
{
  dev_port_fd = open("/dev/port", O_RDWR);
  if(dev_port_fd < 0)
  {
    perror("/dev/port");
    exit(errno);
  }
}

void close_io()
{
  close(dev_port_fd);
  dev_port_fd = -1;
}

void out_byte(int port, unsigned char byte)
{
  off_t s;
  int r;

  s = lseek(dev_port_fd, port, 0);
  if (s < 0) perror("lseek");
  else if (s != port)
    fprintf(stderr, "hmmm: seeking to %d, went to %ld.\n", port, (long)s);

  r = write(dev_port_fd, &byte, 1);
  if (r != 1)
  {
    fprintf(stderr, "hmmm: write returned %d\n", r);
    if (r < 0) perror("write");
  }
}

unsigned char in_byte(int port)
{
  off_t s;
  int r;
  unsigned char ch = 0;

  s = lseek(dev_port_fd, port, 0);
  if (s < 0)
    perror("lseek");
  else if (s != port)
    fprintf(stderr, "hmmm: seeking to %d, went to %ld.\n", port, (long)s);

  r = read(dev_port_fd, &ch, 1);
  if (r != 1)
  {
    fprintf(stderr, "hmmm: read returned %d\n", r);
    if (r < 0) perror("read");
  }

  return ch;
}

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  system("xmms -p &");
  system("/root/xosd.sh Audio &");
}

void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  // FM Radio Button
  system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
  window4 = create_window4 ();
  gtk_window_set_position(GTK_WINDOW(window4), GTK_WIN_POS_CENTER);
  gtk_widget_show (window4);
}


void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  // Change Theme Button
  system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
  window4 = create_window4 ();
  gtk_window_set_position(GTK_WINDOW(window4), GTK_WIN_POS_CENTER);
  gtk_widget_show (window4);
  // system ("/root/day_night_toggle.sh &");
}


void
on_button25_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
// system("/root/notworking.sh &");
  window9 = create_window9 ();  
  gtk_window_set_position(GTK_WINDOW(window9), GTK_WIN_POS_CENTER); 
  gtk_widget_show (window9);
 // system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
}


void
on_button26_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  window4 = create_window4 ();
  gtk_window_set_position(GTK_WINDOW(window4), GTK_WIN_POS_CENTER);
  gtk_widget_show (window4);
  system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
}


void
on_button24_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  //system("gnome-cd --play &");
  //system("/root/xosd.sh \"Compact Disc\" &");
  //sleep(5);
  //system("killall gnome-cd &");

  window7 = create_window7 ();
  gtk_window_set_position(GTK_WINDOW(window7), GTK_WIN_POS_CENTER);
  gtk_widget_show (window7);
  // system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");

}


void
on_button22_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
//system("/root/notworking.sh &");
  window4 = create_window4 ();
  gtk_window_set_position(GTK_WINDOW(window4), GTK_WIN_POS_CENTER);
  gtk_widget_show (window4);
  system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
}


void
on_button29_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  window4 = create_window4 ();
  gtk_window_set_position(GTK_WINDOW(window4), GTK_WIN_POS_CENTER);
  gtk_widget_show (window4);
  system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
}


void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  system("/root/demo_video.sh &");
}


void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  window4 = create_window4 ();
  gtk_window_set_position(GTK_WINDOW(window4), GTK_WIN_POS_CENTER);
  gtk_widget_show (window4);
}


void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  system("mplayer dvd://1");
  /*
   other versions are:
   mplayer dvd://1 -chapter 5-7
   mplayer dvd://1 -dvdangle 2
   NTSC input from V4L - mplayer tv:// -tv driver=v4l:width=640:height=480:outfmt=i420 -vc rawi420 -vo xv
  */
} 


void
on_button40_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

int port = 0x378;
open_io();
g_print("Lock button pressed!!!\n");
out_byte(port,atoi("1"));
usleep(200000);
out_byte(port,atoi("0"));
close_io();
system("/usr/bin/play /usr/share/sounds/Minimize.wav &");

}


void
on_button41_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
/*
  xosd *osd;
  osd = xosd_create (2);
  if (osd == NULL)
    {
      perror ("Could not create \"osd\"");
      exit (1);
    }

  xosd_display (osd, 0, XOSD_string, "Doors Unlocked...");
  sleep (8);
  xosd_destroy (osd);
*/

int port = 0x378;
open_io();
g_print("Unlock button pressed!!!\n");
out_byte(port,atoi("2"));
usleep(200000);
out_byte(port,atoi("0"));
close_io();
system("/usr/bin/play /usr/share/sounds/Maximize.wav &");

}


void
on_button43_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
int port = 0x378;
open_io();
g_print("DriverUp button pressed!!!\n");
out_byte(port,atoi("4"));
usleep(200000);
out_byte(port,atoi("0"));
close_io();
system("/usr/bin/play /usr/share/sounds/Maximize.wav &");
}


void
on_button44_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
int port = 0x378;
open_io();
g_print("PassengerUp button pressed!!!\n");
out_byte(port,atoi("8"));
usleep(200000);
out_byte(port,atoi("0"));
close_io();
system("/usr/bin/play /usr/share/sounds/Maximize.wav &");
}


void
on_button45_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
int port = 0x378;
open_io();
g_print("DriverDown button pressed!!!\n");
out_byte(port,atoi("16"));
usleep(200000);
out_byte(port,atoi("0"));
close_io();
system("/usr/bin/play /usr/share/sounds/Minimize.wav &");
}

void
on_button46_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
int port = 0x378;
open_io();
g_print("PassengerDown button pressed!!!\n");
out_byte(port,atoi("32"));
usleep(200000);
out_byte(port,atoi("0"));
close_io();
system("/usr/bin/play /usr/share/sounds/Minimize.wav &");
}


void
on_button47_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
int port = 0x378;
open_io();
g_print("Trunk button pressed!!!\n");
out_byte(port,atoi("64"));
usleep(200000);
out_byte(port,atoi("0"));
close_io();
system("/usr/bin/play /usr/share/sounds/minimize.wav &");
}


/*
void
on_label5_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
  g_print("NAV TAB SELECTED.\n");
}
*/


void
on_button48_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}

gboolean
on_label5_focus                        (GtkWidget       *widget,
                                        GtkDirectionType  direction,
                                        gpointer         user_data)
{
  g_print("NAV clicked...");
  return FALSE;
}


gboolean
on_eventbox1_focus                     (GtkWidget       *widget,
                                        GtkDirectionType  direction,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
  g_print("Destroy event called...\n");
  gtk_main_quit ();
}


gboolean
on_window1_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  g_print("Delete event called...\n");
  gtk_main_quit ();
  return FALSE;
}


void
on_button58_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  window4 = create_window4 ();
  gtk_window_set_position(GTK_WINDOW(window4), GTK_WIN_POS_CENTER);
  gtk_widget_show (window4);
  system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
}



void
on_button59_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button60_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button14_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  window8 = create_window8 ();
  // gtk_window_set_position(GTK_WINDOW(window8), GTK_WIN_POS_CENTER);
  gtk_widget_show (window8);
  // system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
}

void
on_button15_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button16_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button17_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button62_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button61_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  system ("/root/day_night_toggle.sh &");
}


void
on_button68_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  window4 = create_window4 ();
  gtk_window_set_position(GTK_WINDOW(window4), GTK_WIN_POS_CENTER);
  gtk_widget_show (window4);
  system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
}


void
on_button69_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  system("gpsdrive &");
}


gboolean
on_window1_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  g_print("Key pressed!\n");
  return FALSE;
}

gboolean
on_notebook1_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  g_print("notebook key pressed!\n");
  // next_page(*notebook1);
  return FALSE;
}

void
on_togglebutton1_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  window5 = create_window5 ();
  gtk_window_set_position(GTK_WINDOW(window5), GTK_WIN_POS_CENTER);
  gtk_widget_show (window5);
  // system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");
}


void
on_togglebutton3_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  window5 = create_window5 ();
  gtk_window_set_position(GTK_WINDOW(window5), GTK_WIN_POS_CENTER);
  gtk_widget_show (window5);
  // system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");

}


void
on_togglebutton2_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  window9 = create_window9 ();
  gtk_window_set_position(GTK_WINDOW(window9), GTK_WIN_POS_CENTER);
  gtk_widget_show (window9);
  // system("/usr/bin/play /usr/share/sounds/Default_Beep.wav &");

}


void
on_button73_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}

